% COMMDVBT_TABLEGEN Generate interleaver and modulator lookup tables for 
% COMMDVBT demo


%   Copyright 1996-2008 The MathWorks, Inc.
%   $Revision: 1.1.6.5 $  $Date: 2008/06/06 13:26:13 $
%
 
%
%odabire vrstu mapiranja
%1 - 64-qam, 2 - 16-qam, 3 - qpsk

%odabir = menu('Odaberi n u qam', '64', '16', '4');
%odabir2 = menu('Odaberi FEC', '1/2', '2/3', '3/4','5/6','7/8');
%odabir3 = menu('Odaberi guard', '1/4', '1/8', '1/16','1/32');
% Section numbers refer to the ETSI DVB-T Standard,
% EN 300 744 V1.1.2 (1997-08)
%

%
% Compute lookup table for inner bit-wise interleaver 
% as per section 4.3.4.1
% prosireno za qpsk i 16-qam

% Initial table setup

switch odabir
    case 1
        
dvb_bit_int_table = 1:756;
buffer_bitint=size(dvb_bit_int_table,2);
dvb_bit_int_table = reshape(dvb_bit_int_table, 6, 126);

% 64-QAM non-hierarchical demultiplexing
dvb_bit_int_table = dvb_bit_int_table([1 4 2 5 3 6],:);

% Six individual interleavers
dvb_bit_int_table(1,:) = dvb_bit_int_table(1,mod([0:125] +  0,126) + 1);
dvb_bit_int_table(2,:) = dvb_bit_int_table(2,mod([0:125] + 63,126) + 1);
dvb_bit_int_table(3,:) = dvb_bit_int_table(3,mod([0:125] +105,126) + 1);
dvb_bit_int_table(4,:) = dvb_bit_int_table(4,mod([0:125] + 42,126) + 1);
dvb_bit_int_table(5,:) = dvb_bit_int_table(5,mod([0:125] + 21,126) + 1);
dvb_bit_int_table(6,:) = dvb_bit_int_table(6,mod([0:125] + 84,126) + 1);
    
    case 2
        
dvb_bit_int_table = 1:504;
buffer_bitint=size(dvb_bit_int_table,2);
dvb_bit_int_table = reshape(dvb_bit_int_table, 4, 126);

% 16-QAM non-hierarchical demultiplexing
dvb_bit_int_table = dvb_bit_int_table([1 3 2 4],:);

% 4 individual interleavers
dvb_bit_int_table(1,:) = dvb_bit_int_table(1,mod([0:125] +  0,126) + 1);
dvb_bit_int_table(2,:) = dvb_bit_int_table(2,mod([0:125] + 63,126) + 1);
dvb_bit_int_table(3,:) = dvb_bit_int_table(3,mod([0:125] +105,126) + 1);
dvb_bit_int_table(4,:) = dvb_bit_int_table(4,mod([0:125] + 42,126) + 1);
    
    case 3
        
dvb_bit_int_table = 1:252;
buffer_bitint=size(dvb_bit_int_table,2);
dvb_bit_int_table = reshape(dvb_bit_int_table, 2, 126);

% QPSK non-hierarchical demultiplexing
dvb_bit_int_table = dvb_bit_int_table([1 2],:);

% 2 individual interleavers
dvb_bit_int_table(1,:) = dvb_bit_int_table(1,mod([0:125] +  0,126) + 1);
dvb_bit_int_table(2,:) = dvb_bit_int_table(2,mod([0:125] + 63,126) + 1);

        
end;


% Flatten matrix into lookup table - za sve modove
dvb_bit_int_table = dvb_bit_int_table(:);

%
% Compute lookup table for inner symbol interleaver 
% as per section 4.3.4.2
%

% Following Figure 8a and accompanying equations
%promijenjeno za 8k mod
q = 0;
h = zeros(1,8192);
R = zeros(1,12);
for indx = 0:8191,
   if indx == 2,
      R(1) = 1;
   end
   Rsum = R(11)*2^11+R(8)*2^10+R(5)*2^9+R(7)*2^8+...                             
      R(1)*2^7+R(6)*2^6+R(12)*2^5+R(3)*2^4+R(10)*2^3+...
      R(4)*2^2+R(2)*2^1+R(9)*2^0;             
   h(q+1) = rem(indx,2)*2^12+Rsum;
   if h(q+1)<6048,
      q = q + 1;
   end
   R = [R(2:12) xor(xor(R(1),R(2)),xor(R(5),R(7)))];
end
dvb_sym_int_table = h(1:6048)+1;


% Clear unnecessary variables from workspace
clear R Rsum h indx q

% Expand table to accommodate 6-bit words
% ovo je zajednicko svim FEC-ovima
switch odabir
    case 1
dvb_sym_int_table = [dvb_sym_int_table*6-5; 
	                 dvb_sym_int_table*6-4;
					 dvb_sym_int_table*6-3;
					 dvb_sym_int_table*6-2;
					 dvb_sym_int_table*6-1; 
					 dvb_sym_int_table*6 ;
                     ];
                 % Reading the values from Figure 9a
dvbt_qam = [ 7 + 7i
            -7 + 7i
             7 - 7i
            -7 - 7i
             1 + 7i
            -1 + 7i
             1 - 7i
            -1 - 7i
             7 + 1i
            -7 + 1i
             7 - 1i
            -7 - 1i
             1 + 1i
            -1 + 1i
             1 - 1i
            -1 - 1i
             5 + 7i
            -5 + 7i
             5 - 7i
            -5 - 7i
             3 + 7i
            -3 + 7i
             3 - 7i
            -3 - 7i
             5 + 1i
            -5 + 1i
             5 - 1i
            -5 - 1i
             3 + 1i
            -3 + 1i
             3 - 1i
            -3 - 1i
             7 + 5i
            -7 + 5i
             7 - 5i
            -7 - 5i
             1 + 5i
            -1 + 5i
             1 - 5i
            -1 - 5i
             7 + 3i
            -7 + 3i
             7 - 3i
            -7 - 3i
             1 + 3i
            -1 + 3i
             1 - 3i
            -1 - 3i
             5 + 5i
            -5 + 5i
             5 - 5i
            -5 - 5i
             3 + 5i 
            -3 + 5i 
             3 - 5i 
            -3 - 5i 
             5 + 3i
            -5 + 3i
             5 - 3i
            -5 - 3i
             3 + 3i
            -3 + 3i
             3 - 3i
            -3 - 3i ];

% Normalization factor from Section 4.4
dvbt_qam = dvbt_qam/sqrt(42);
buffer=36288;
bitovi=6;
port=1;
odabir_mat=[1:36288];
    
    case 2

% Expand table to accommodate 4-bit words
dvb_sym_int_table = [dvb_sym_int_table*4-3; 
	                 dvb_sym_int_table*4-2;
					 dvb_sym_int_table*4-1;
					 dvb_sym_int_table*4;
					 ];
%16-qam
dvbt_qam = [ 3 + 3i
            -3 + 3i
             3 - 3i
            -3 - 3i
             1 + 3i
            -1 + 3i
             1 - 3i
            -1 - 3i
             3 + 1i
            -3 + 1i
             3 - 1i
            -3 - 1i
             1 + 1i
            -1 + 1i
             1 - 1i
            -1 - 1i];
 
dvbt_qam = dvbt_qam/sqrt(10);
buffer=24192;
bitovi=4;
port=2;
odabir_mat=[36289:60480];
    
    case 3

 % Expand table to accommodate 2-bit words       
dvb_sym_int_table = [dvb_sym_int_table*2-1; 
	                 dvb_sym_int_table*2;
					 ];
%qpsk
dvbt_qam = [ 1 + 1i
            -1 + 1i
             1 - 1i
            -1 - 1i];
 
dvbt_qam = dvbt_qam/sqrt(2);

buffer=12096;
bitovi=2;
port=3;
odabir_mat=[60481:72576];

end;

delay4=0; %za sve osim za FEC=7/8 i QPSK
% ovo ovisi i o FEC-u i o modulacijskom postupku
switch odabir2
    case 1 %FEC 1/2
        punct_mat=[1 1]';
        buffer1=1632;
        buffer3=1632*2;
        delay3=657;
        switch odabir
            case 1
                delay1=1632*13;
                delay3=926;
            case 2
                delay1=1632*9;
                delay3=572;
            case 3
                delay1=1632*5;
                delay3=218;
        end;
    case 2 %FEC 2/3
        punct_mat=[1 0 1 1]';
        buffer1=1632;
         buffer3=1632*3/2;
         switch odabir
            case 1
                delay1=1632*17;
                delay3=1280;
            case 2
                delay1=1632*12;
                delay3=1352;
            case 3
                delay1=1632*7;
                delay3=1424;
        end;
    case 3 %FEC 3/4
        punct_mat=[1 1 0 1 1 0]';
        buffer1=1632;
         buffer3=1632*4/3;
         switch odabir
            case 1
                delay1=1632*19;
                delay3=1457;
            case 2
                delay1=1632*13;
                delay3=926;
            case 3
                delay1=1632*7;
                delay3=395;
        end;
    case 4 %FEC 5/6
        %punct_mat=[1 0 1 0 1 1 1 0 1 0]';
        punct_mat=[1 1 0 1 1 0 0 1 1 0]';
        buffer1=1635;
        buffer3=buffer1*6/5;
         switch odabir
            case 1
                delay1=1632*23;
                delay3=1628;
            case 2
                delay1=1632*16;
                delay3=494;
            case 3
                delay1=1632*10;
                delay3=992;
        end;
    case 5 %FEC 7/8
        %punct_mat=[1 0 0 0 1 0 1 1 1 1 1 0 1 0]';
        punct_mat=[1 1 0 1 0 1 0 1 1 0 0 1 1 0]';
        
        buffer1=1638;
        buffer3=buffer1*8/7;
        switch odabir
            case 1
                delay1=1632*23;
                delay3=75;
                delay4=4; % da viterbi ispravno dekodira
            case 2
                delay1=1632*17;
                delay3=1091;
            case 3
                delay1=1632*10;
                delay3=468;
                delay4=4; % da viterbi ispravno dekodira
        end;
end;

switch odabir3
    case 1
        guard=1/4;
    case 2
        guard=1/8;
    case 3
        guard=1/16;
    case 4
        guard=1/32;
end;

% Flatten matrix into lookup table
dvb_sym_int_table = dvb_sym_int_table(:);

% Set the sample time
%Ts = 0.000224*2176/9072/188; staro, za 2k
Ts = 0.000896*buffer3/size(dvb_sym_int_table,1)/188;

%d/a i a/d pretvorba - ulazni parametri

%Tu=896e-6; %useful OFDM symbol period
%T=Tu/8192; %baseband elementary period
%G=0; %choice of 1/4, 1/8, 1/16, and 1/32
%delta=G*Tu; %guard band duration
%Ts=delta+Tu; %total OFDM symbol period
%FS=4*4096; %IFFT/FFT length
%q=10; %carrier period to elementary period ratio
%fc=q*1/T; %carrier frequency
%Rs=4*fc; %simulation period
%t=0:1/Rs:Tu;
%delay=64;
%N=6817; %number of subcarriers

%ovdje racunam tocna mjesta pilot kanala, TPS i korisnih kanala
%time se ubrza rad kasnijih embedded funkcija, da ne trebaju ispocetka 
%racunati mjesta gdje se oni nalaze

%kontinuirani piloti su uvijek na tim mjestima
cont=[...
0 48 54 87 141 156 192 ...
201 255 279 282 333 432 450 ...
483 525 531 618 636 714 759 ...
765 780 804 873 888 918 939 ...
942 969 984 1050 1101 1107 1110 ...
1137 1140 1146 1206 1269 1323 1377 ...
1491 1683 1704 1752 1758 1791 1845 ...
1860 1896 1905 1959 1983 1986 2037 ...
2136 2154 2187 2229 2235 2322 2340 ...
2418 2463 2469 2484 2508 2577 2592 ...
2622 2643 2646 2673 2688 2754 2805 ...
2811 2814 2841 2844 2850 2910 2973 ...
3027 3081 3195 3387 3408 3456 3462 ...
3495 3549 3564 3600 3609 3663 3687 ...
3690 3741 3840 3858 3891 3933 3939 ...
4026 4044 4122 4167 4173 4188 4212 ...
4281 4296 4326 4347 4350 4377 4392 ...
4458 4509 4515 4518 4545 4548 4554 ...
4614 4677 4731 4785 4899 5091 5112 ...
5160 5166 5199 5253 5268 5304 5313 ...
5367 5391 5394 5445 5544 5562 5595 ...
5637 5643 5730 5748 5826 5871 5877 ...
5892 5916 5985 6000 6030 6051 6054 ...
6081 6096 6162 6213 6219 6222 6249 ...
6252 6258 6318 6381 6435 6489 6603 ...
6795 6816]+ones(177,1)';



pilot(701,4)=0; %mjesta pilota
for k=1:4 %framenum (1-4)
    j=0;
    if k==1 scat=(1+3*(mod(0,4))):12:6817; end; %rasprseni piloti ovise o framenum (1-4)
    if k==2 scat=(1+3*(mod(1,4))):12:6817; end;
    if k==3 scat=(1+3*(mod(2,4))):12:6817; end;
    if k==4 scat=(1+3*(mod(3,4))):12:6817; end;
    pom=sort([scat cont])';
    pom(746)=6817;
    for i=1:size(pom,1)-1
        if pom(i+1)~=pom(i)
            j=j+1;
            pilot(j,k)=pom(i);
        end;
    end;
end;
pilot(701,:)=[6817;6817;6817;6817];%zadnji pilot je uvijek taj a nisam ga mogao prethodno provjeriti

%TPS kanali su uvijek na istim mjestima (68 ukupno po simbolu)

TPS=[ ...
34 50 209 346 413 569 595 688 ...
790 901 1073 1219 1262 1286 1469 1594 ...
1687 1738 1754 1913 2050 2117 2273 2299 ...
2392 2494 2605 2777 2923 2966 2990 3173 ...
3298 3391 3442 3458 3617 3754 3821 3977 ...
4003 4096 4198 4309 4481 4627 4670 4694 ...
4877 5002 5095 5146 5162 5321 5458 5525 ...
5681 5707 5800 5902 6013 6185 6331 6374 ...
6398 6581 6706 6799]+ones(68,1)'; %TPS signali

%korisni signali su oni koji nisu piloti ili TPS; ima ih 6048 po simbolu

korisni(6048,4)=0;

for k=1:4
    pom=sort([pilot(:,k)' TPS])';
    j=0;
    for i=1:6817
        if size((find(pom == i)),1)==0
            j=j+1;
            korisni(j,k)=i;
        end;
    end;
end;

%ispod su vrijednosti navedene u standardu, koje sluze da se ispita koliki
%mora biti odnos C/N da se dobije BER=2  10-4 nakon Viterbi dekodera
%i QEF nakon RS dekodera
clear i;

atten=[0.057662...
       0.176809...
       0.407163...
       0.303585...
       0.258782...
       0.061831...
       0.150340...
       0.051534...
       0.185074...
       0.400967...
       0.295723...
       0.350825...
       0.262909...
       0.225894...
       0.170996...
       0.149723...
       0.240140...
       0.116587...
       0.221155...
       0.259730];
   
K=1*ones(20,1)'; 
Ka=10; %za rician fading channel - linearan, ne u dB
doppler_kanal=zeros(20,1)';
delay_kanal=[1.003019...
             5.422091...
             0.518650...
             2.751772...
             0.602895...
             1.016585...
             0.143556...
             0.153832...
             3.324866...
             1.935570...
             0.429948...
             3.228872...
             0.848831...
             0.073883...
             0.203952...
             0.194207...
             0.924450...
             1.381320...
             0.640512...
             1.368671]*10^-6;
         
phase_kanal=[4.855121...
            3.419109...
            5.864470...
            2.215894...
            3.758058...
            5.430202...
            3.952093...
            1.093586...
            5.775198...
            0.154459...
            5.928383...
            3.053023...
            0.628578...
            2.128544...
            1.099463...
            3.462951...
            3.664773...
            2.833799...
            3.334290...
            0.393889];